import QtQuick 1.0
import com.meego 1.0
import com.nokia.extras 1.1
// import com.nokia.extras 1.0
import "." as MyComponents


Page {
    
//     orientationLock: PageOrientation.LockPortrait
//     orientationLock: PageOrientation.LockLandscape
    
    
    id: mainPage
    tools: toolbar

    
    
    //Variables
    property bool useLucidDreamSong
    property int lucidDreamSongDelay
    property int lucidDreamSongVolume
    property string lucidDreamSong
    
    property bool useAlarm
    property int alarmTimeHour
    property int alarmTimeMinute
    property int alarmTimeWindow
    
    property bool useWakeUpSong
    property int wakeUpVolume
    property string wakeUpSong
    

    
        

    function loadParametersFromPythonLucidDreamMusic(a1, a2, a3, a4){
	useLucidDreamSong = a1
	lucidDreamSongDelay = a2
	lucidDreamSongVolume = a3
	lucidDreamSong = a4
    }   

    function loadParametersFromPythonAlarm(a1, a2, a3, a4){
	useAlarm = a1
	alarmTimeHour = a2
	alarmTimeMinute = a3
	alarmTimeWindow = a4	
    }   

    function loadParametersFromPythonWakeUpMusic(a1, a2, a3){
	useWakeUpSong = a1
	wakeUpVolume = a2
	wakeUpSong = a3	
    }
    
    
    
    function sendParameters2Python(){
	console.log("useLucidDreamSong:", useLucidDreamSong)
	console.log("lucidDreamSongDelay:", lucidDreamSongDelay)
	console.log("lucidDreamSongVolume:", lucidDreamSongVolume)
	console.log("lucidDreamSong:", lucidDreamSong)
	console.log("useAlarm:", useAlarm)
	console.log("alarmTimeHour:", alarmTimeHour)
	console.log("alarmTimeMinute:", alarmTimeMinute)
	console.log("alarmTimeWindow:", alarmTimeWindow)
	console.log("useWakeUpSong:", useWakeUpSong)
	console.log("wakeUpVolume:", wakeUpVolume)
	console.log("wakeUpSong:", wakeUpSong)   
	
	qml_to_python.StoreParameters(useLucidDreamSong, lucidDreamSongDelay, lucidDreamSongVolume, lucidDreamSong, useAlarm, alarmTimeHour, alarmTimeMinute, alarmTimeWindow, useWakeUpSong, wakeUpVolume, wakeUpSong)
    }
    
    
    
    
    function updateScreen(){	
	sUseLucidDream.checked = useLucidDreamSong
	if (useLucidDreamSong){
	    lblDreamMusic.color = "white"
	    lblDreamMusicDelay.color = "white"
	    lblDreamMusicfile.color = "white"
	    lblDreamMusicVolume.color = "white"
	    bDreamMusic.enabled = true
	}
	else{
	    lblDreamMusic.color = "grey"
	    lblDreamMusicDelay.color = "grey"
	    lblDreamMusicfile.color = "grey"
	    lblDreamMusicVolume.color = "grey"
	    bDreamMusic.enabled = false
	}
	
	lblDreamMusicVolume.text = qsTr("Volume:") + " " + lucidDreamSongVolume + "%"
	lblDreamMusicDelay.text = qsTr("Start after") + " " + Math.round(lucidDreamSongDelay/60)  + " " + qsTr("minutes in light or deep sleep")
	lblDreamMusicfile.text = qsTr("File:") + " " + lucidDreamSong
	
      
	//----------------------------------------------------
      	sUseAlarm.checked = useAlarm	
	
	if (useAlarm){
	    lblAlarm.color = "white"
	    lblAlarmTime.color = "white"
	    bAlarmTime.enabled = true
	    bAlarmWindow.enabled = true
	    sUseWakeUpMusic.enabled = true
	    sUseWakeUpMusic.enabled = true
	}
	else{
	    lblAlarm.color = "grey"
	    lblAlarmTime.color = "grey"
	    bAlarmTime.enabled = false
	    bAlarmWindow.enabled = false
	    bWakeUpMusic.enabled = false
	    sUseWakeUpMusic.checked = false
	    sUseWakeUpMusic.enabled = false
	}
	
	var windowstarttime = alarmTimeHour*60 + alarmTimeMinute - alarmTimeWindow
	var h = Math.floor(windowstarttime/60)
	var m = windowstarttime-h*60
	if(h<0)h=h+24;
	lblAlarmTime.text = qsTr("Alarm time:") + " " + h + ":" + ((m < 10 ? "0" : "" ) + m) + " - " + alarmTimeHour + ":" + ((alarmTimeMinute < 10 ? "0" : "" ) + alarmTimeMinute)
	
	
	
	//----------------------------------------------------
	sUseWakeUpMusic.checked = useWakeUpSong
	if(useWakeUpSong){
	    lblWakeUpMusic.color = "white"
	    lblWakeUpMusicVolume.color = "white"
	    lblWakeUpMusicfile.color = "white"
	    bWakeUpMusic.enabled = true
	}
	else{
	    lblWakeUpMusic.color = "gray"
	    lblWakeUpMusicVolume.color = "grey"
	    lblWakeUpMusicfile.color = "grey"
	    bWakeUpMusic.enabled = false
	}
	lblWakeUpMusicVolume.text = qsTr("Volume:") + " " + wakeUpVolume + "%"
	lblWakeUpMusicfile.text = qsTr("File:") + " " + wakeUpSong	
    }
    
    

//*******************************************************



    Flickable {
        id: flickable
        anchors.fill: parent    
//         contentHeight: column.height
        contentHeight: 800
        flickableDirection: Flickable.VerticalFlick
        
        Column{
	    id: column
	    anchors.fill: parent 
	    anchors.leftMargin: 5
	    spacing: 5
// 	         anchors.centerIn: parent
// 	         anchors.horizontalCenter: parent.horizontalCenter
        
	    Label {
		  text: qsTr("SleepAnalyser")
		  font.bold: true
		  font.pixelSize: 48
		  anchors.horizontalCenter: column.horizontalCenter
	    }      	    
	    
	    Image{
		source: "../images/SleepAnalyser128.png"
		anchors.horizontalCenter: parent.horizontalCenter
	    }
    
    
	    Rectangle{ //Spacer, hide it outside the screen
		height: 20; width: 1; x: -1000
	    }
    
    
    
    
//----------------------- Dream Music ---------------------------------------
	    Row {
		spacing: 10
		width: parent.width
		
		Image{
		    id: imgDreamMusic
		    source: "../images/music_green.png"
		}
		Label{
		    id: lblDreamMusic
		    text: qsTr("Dream music")
		    font.pixelSize: 32
		    font.bold: true
		    anchors.verticalCenter: imgDreamMusic.verticalCenter
		    width: parent.width - 200
		}
		Switch {
                    id: sUseLucidDream
//                     checked: false
		    onCheckedChanged: { 
			useLucidDreamSong=sUseLucidDream.checked; 	     
			updateScreen(); 
		    }
		    anchors.verticalCenter: imgDreamMusic.verticalCenter
		}
                Button{
		    id: bDreamMusic
		    width: 50
		    iconSource: "../images/configure.png"
		    onClicked: {
			pageStack.push(pageDreamMusic)
		    }
		}
	    }
    
	    Label{
	      
		id: lblDreamMusicfile
		font.pixelSize: 20
		width: flickable.width
		wrapMode: Text.Wrap
		color: "grey"
	    }
	    Label{
		id: lblDreamMusicVolume
		font.pixelSize: 20
		wrapMode: Text.Wrap
		color: "grey"
	    }
	    Label{
		id: lblDreamMusicDelay
		font.pixelSize: 20
		width: flickable.width
		wrapMode: Text.Wrap
		color: "grey"
	    }

	    Rectangle{
		height: 1
		width: parent.width
		color: "gray"
	    }






//----------------------- Alarm ---------------------------------------
	    Row {
		spacing: 10
		width: parent.width
		
		Image{
		    id: imgAlarmMusic
		    source: "../images/SleepAnalyser48.png"
		}
		Label{
		    id: lblAlarm
		    text: qsTr("Alarm")
		    font.pixelSize: 32
		    font.bold: true
		    anchors.verticalCenter: imgAlarmMusic.verticalCenter
		    width: parent.width - 200
		}
		Switch {
                    id: sUseAlarm
//                     checked: true
		    anchors.verticalCenter: imgAlarmMusic.verticalCenter
		    onCheckedChanged: {		      
			useAlarm=sUseAlarm.checked;  	     
			updateScreen(); 
		    }
                }
	    }
    
    
	    Label{	      
		id: lblAlarmTime
// 		text: "Alarm time: 6:30 - 7:00"
		font.pixelSize: 20
		color: "grey"
	    }
	    
	    Row{
		spacing: 5
		width: parent.width
		
                Button{
		    id: bAlarmTime
		    text: qsTr("Time")
		    width: parent.width/2-5
		    onClicked: {
			calldialogAlarmTime(); 
		    }
		}
                Button{		    
		    id: bAlarmWindow
		    text: qsTr("Time window")
		    width: parent.width/2-5
		    onClicked: {
			calldialogAlarmTimeWindow();
		    }
		}
	    }

	    Rectangle{
		height: 1
		width: parent.width
		color: "gray"
	    }






//----------------------- Wake Up Music ---------------------------------------
	    Row {
		spacing: 10
		width: parent.width
		
		Image{
		    id: imgWakeUpMusic
		    source: "../images/music_red.png"
		}
		Label{
		    id: lblWakeUpMusic
		    text: qsTr("Wake up music")
		    font.pixelSize: 32
		    font.bold: true
		    anchors.verticalCenter: imgWakeUpMusic.verticalCenter
		    width: parent.width - 200
		}
		Switch {
                    id: sUseWakeUpMusic
//                     checked: false
                    onCheckedChanged:{
		      useWakeUpSong=sUseWakeUpMusic.checked;	     
		      updateScreen(); 
		    }
		    anchors.verticalCenter: imgWakeUpMusic.verticalCenter
                }
                Button{
		    id: bWakeUpMusic
		    width: 50
		    iconSource: "../images/configure.png"
		    onClicked: {
			pageStack.push(pageWakeUpMusic)
		    }
		}
	    }
    
	    Label{	      
		id: lblWakeUpMusicfile
// 		text: "File: MyDocs/Music/Abba - bla bla bla bla bla bla bla bla unified/bla bla.mp3"
		font.pixelSize: 20
		width: flickable.width
		wrapMode: Text.Wrap
		color: "grey"
	    }
	    Label{
		id: lblWakeUpMusicVolume
// 		text: "Volume: 30%"
		font.pixelSize: 20
		wrapMode: Text.Wrap
		color: "grey"
	    }



	}
	
	
	
	
    
    }
    
    
    
    
    
    
    
    
    
    
    
//*******************************************************


    ToolBarLayout {
	id: toolbar
	
	ToolButtonRow {
	    ToolButton {
                id: bstart
                text: qsTr("Start")
// 		style: PositiveButtonStyle {}
                onClicked: {
//                     pageStack.push(advancedPage)
		    console.log("StartRecording")
		    sendParameters2Python()
		    var r = qml_to_python.StartRecording()
// 		    var r = true
		    if(r == true){
			pageRecording.animation_id = 0;
			pageRecording.elapsed_time = 0;
			if(useAlarm) pageRecording.alarm_time = lblAlarmTime.text;
			else pageRecording.alarm_time = qsTr("Alarm time:") + " " + qsTr("Not set")
			pageRecording.lucid_dream = qsTr("Lucid dream music:") + " " + qsTr("Not set")
			pageRecording.wake_up_music = qsTr("Wake up music:") + " " + qsTr("Not set")
			pageStack.push(pageRecording);
		    }
                }
	    }
	    
	    
	    ToolButton {
                id: bview
                text: qsTr("View")
                onClicked: {
                    pageStack.push(pageView)
		    console.log("ViewRecord")
		    sendParameters2Python()
		    updateScreen()
                }
	    }
	  
	} //needed, so the menu is on the right side	      
	    
	ToolIcon {
	    iconId: "toolbar-view-menu" ;
	    onClicked: mainPageMenu.open();
	}
    }   
    
    
    


//*******************************************************


    
    
    Component {
	id: used_for_on_complete_signal
	Rectangle {}
    }      
    Rectangle {
	Component.onCompleted: {
	    theme.inverted=true;	     
	    updateScreen();
	}
    }
    
    
    
    
//*******************************************************

    
    function calldialogAlarmTime() {
	console.log("calldialogAlarmTime");
      
	for (var i = 0; i <= 23; i++) {
            hourList.append({"value" : i+""});
        }

        for (var i = 0; i <= 55; i=i+5) {
            minuteList.append({"value" : i+""});
        }
	hourColumn.selectedIndex = alarmTimeHour;
	minuteColumn.selectedIndex = (alarmTimeMinute/5);
        
	dialogAlarmTime.open();
    }
    
    function setAlarmTime() {
	alarmTimeHour = hourList.get(hourColumn.selectedIndex).value;
	alarmTimeMinute = minuteList.get(minuteColumn.selectedIndex).value;
	updateScreen();
    }

    TumblerDialog{
	id: dialogAlarmTime
	titleText: qsTr("Alarm time")
	columns: [ hourColumn, minuteColumn ]
	acceptButtonText: qsTr("Ok")
	rejectButtonText: qsTr("Cancel")
	onAccepted: setAlarmTime()
    }
    
     TumblerColumn {
        id: hourColumn
        items: ListModel { id: hourList }
        label: qsTr("Hour")
    }

    TumblerColumn {
        id: minuteColumn
        items: ListModel {id: minuteList }
        label: "Minute"
    }
    
    
    
    
//*******************************************************

    
    function calldialogAlarmTimeWindow() {
        for (var i = 0; i <= 55; i=i+5) {
            minutesList.append({"value" : i+""});
        }
	minutesColumn.selectedIndex = (alarmTimeWindow/5);
      
	dialogAlarmTimeWindow.open();
    }
    
    function setAlarmTimeWindow() {
	alarmTimeWindow = minutesList.get(minutesColumn.selectedIndex).value;
	updateScreen();
    }

    TumblerDialog{
	id: dialogAlarmTimeWindow
	titleText: qsTr("Alarm time window")
	columns: [ minutesColumn ]
	acceptButtonText: qsTr("Ok")
	rejectButtonText: qsTr("Cancel")
	onAccepted: setAlarmTimeWindow()
    }

    TumblerColumn {
        id: minutesColumn
        items: ListModel {id: minutesList }
        label: qsTr("Minutes")
    }
    
    
    
    
//*******************************************************
    
    
    Menu {
        id: mainPageMenu
        MenuLayout {

            MenuItem {
                text: qsTr("Help")
                onClicked: { help.open(); }
            }
            MenuItem {
                text: qsTr("About")
                onClicked: { about.open(); }
            }
            MenuItem {
                text: qsTr("Settings")
                onClicked: { pageStack.push(pageSettings); }
            }
            MenuItem {
                text: qsTr("Test recording")
                onClicked: { 
		    var r = qml_to_python.StartTestRecording()
		    if(r == true)pageStack.push(pageRecording);
		}
            }
            MenuItem {
                text: qsTr("Donate")
                onClicked: { about.open(); }
            }
        }
    }    
    
//*******************************************************

    MyComponents.DreamMusicPage {
        id: pageDreamMusic
    }

    MyComponents.WakeUpMusicPage {
        id: pageWakeUpMusic
    }
        
    MyComponents.RecordingPage {
        id: pageRecording
    }   
        
    MyComponents.ViewPage {
        id: pageView
    }
        
    MyComponents.SettingsPage {
        id: pageSettings
    }
}
