import QtQuick 1.0
import com.meego 1.0
import com.nokia.extras 1.1
import "." as MyComponents
// import myGraph 1.0

Page {
    
    id: pageRecording
    tools: toolbar

//     anchors.margins: 10

    //Variables
    property int animation_id
    property int elapsed_time
    property string alarm_time
    property string lucid_dream
    property string wake_up_music




    //I dont know how Python can force a graph redraw, so I let it inform QML which then here forces a redraw :)
    function tellQMLToRedrawGraph() {
        console.log("tellQMLToRedrawGraph")
        flickable.contentX=flickable.contentX -1 
        flickable.contentX=flickable.contentX + 1
    }


    
    //Call from Python to resize the graph
    function updateGraphWidth2(width, height) {
//         console.log("updateGraphWidth2")
        graph01.width=width
        flickable.width=width
        graph01.height=height
        flickable.height=height
//         console.log("Done")
    }



//     function startRecording() {
// 	console.log("startRecording")
// 	timerRefreshGraph.running = true
//     }



    Timer {
	id: timerRefreshGraph
	interval: 1000; running: true; repeat: true
	onTriggered: {
	    if(pageRecording.visible == true){
//  		console.log("pageRecording is visible, update graph")
// 		tellQMLToRedrawGraph()  		
		animation_id = animation_id +1
		elapsed_time = elapsed_time + 1
		if(animation_id == 8)animation_id=0;
		imgAnimation.source = "../images/anim/"+animation_id+".png"
		if(elapsed_time < 60){
		    var txt = elapsed_time + " " + qsTr("seconds")
		}
		else if(elapsed_time < 3600){
		    var m = Math.floor(elapsed_time / 60)
		    var s = elapsed_time - m * 60
		    var txt = m + "m " + s + "s"		  
		}
		else{
		    var h = Math.floor(elapsed_time / 3600)
		    var m = Math.floor((elapsed_time - h * 3600 ) / 60)
		    var s = elapsed_time - h * 3600 - m * 60
		    var txt = h + "h " + m + "m " + s + "s"		  
		}	  
		lblElapsedTime.text = qsTr("Elapsed time: ") + txt
	    }
	}
    }



//*******************************************************



    Column{
	id: column
	anchors.fill: parent 
	anchors.leftMargin: 5
	spacing: 5
// 	         anchors.centerIn: parent
// 	         anchors.horizontalCenter: parent.horizontalCenter
    
	Label {
	      text: qsTr("SleepAnalyser")
	      font.bold: true
	      font.pixelSize: 48
	      anchors.horizontalCenter: column.horizontalCenter
	}      	    
	
	Image{
	    id: imgAnimation
	    source: "../images/anim/0.png"
	    anchors.horizontalCenter: parent.horizontalCenter
	}
    
//         Flickable {  
//             id: flickable
//             width: 1000
//             height: 1000
//             clip: true
//             boundsBehavior: Flickable.StopAtBounds
//             
//             Graph {
//                 id: graph01
//                 width: 1000
//                 height: 1000
//                 clip: true
//             }
//             contentWidth: graph01.width; contentHeight: graph01.height	      
//         }

	Label {
	    text: qsTr("Recording...")
	    font.bold: true
	    font.pixelSize: 24
	    anchors.horizontalCenter: column.horizontalCenter
	}     
	Label {
	    id: lblElapsedTime
	    text: qsTr("Elapsed time:") + " " + 0 + " seconds"
	    font.bold: true
	    font.pixelSize: 18
	    anchors.horizontalCenter: column.horizontalCenter
	}   
	
	
	Label {
	    id: lblLucidDream
	    text: lucid_dream;
	    font.bold: true
	    font.pixelSize: 18
	    anchors.horizontalCenter: column.horizontalCenter
	} 
	Label {
	    id: lblAlarmTime
	    text: alarm_time;
	    font.bold: true
	    font.pixelSize: 18
	    anchors.horizontalCenter: column.horizontalCenter
	} 	
	Label {
	    id: lblWakeUpMusic
	    text: wake_up_music;
	    font.bold: true
	    font.pixelSize: 18
	    anchors.horizontalCenter: column.horizontalCenter
	}  	    


   }
    
    
    
    
    
    
    
    
    
    
    
//*******************************************************


    ToolBarLayout {
	id: toolbar
	
	ToolButtonRow {
	    ToolButton {
                id: bStop
                text: "Stop"
                onClicked: {
		  console.log("Stop")
// 		  timerRefreshGraph.running = false
		  var r = qml_to_python.StopRecording()
		  if(r == true)pageStack.pop();
		}
	    }

	  
	} //needed, so the menu is on the right side	      
	    
// 	ToolIcon {
// 	    iconId: "toolbar-view-menu" ;
// 	    onClicked: mainPageMenu.open();
// 	}
    }   
    
    
    
//*******************************************************

   
}
